import org.openqa.selenium.By
import org.openqa.selenium.Keys
import org.openqa.selenium.firefox.FirefoxDriver
import org.openqa.selenium.support.ui.ExpectedConditions
import org.openqa.selenium.support.ui.WebDriverWait
import java.lang.Thread.sleep


object Browser {
    private var driver = FirefoxDriver()
    fun login(username: String, password: String) {
        driver.get("https://studip.uni-hannover.de")

        driver.get(driver.findElement(By.xpath("/html/body/div[1]/div[3]/div/div[3]/nav/div[1]/a")).getAttribute("href"))

        driver.findElement(By.xpath("//*[@id=\"username\"]")).sendKeys(username)
        driver.findElementByXPath("//*[@id=\"password\"]").sendKeys(password + Keys.ENTER)

        sleep(2000)
    }

    fun getCourses(): List<Course> {
        driver.get("https://studip.uni-hannover.de/dispatch.php/my_courses")

        val wait = WebDriverWait(driver, 10)
        wait.until(ExpectedConditions.visibilityOfAllElementsLocatedBy(By.xpath("/html/body/div/div[3]/div[2]/div[2]/div/table/tbody")))

        return driver.findElementByXPath("/html/body/div/div[3]/div[2]/div[2]/div/table/tbody")
            .findElements(By.xpath("tr/td[3]/a")).map {
                Course(
                    it.getAttribute("href").toString(),
                    it.text)
            }
    }

    fun getVideoLink(video: Video): Video {
        driver.get(video.link)

        driver.switchTo().frame(driver.findElement(By.xpath("/html/body/div/div[3]/div[2]/div[2]/div/div[2]/iframe")))

        val link = driver.findElementByXPath("/html/body/a").getAttribute("href")
        val node = link.split("nodes/")[1].split("/")[0]
        val resolution = link.split("=").filter { it.startsWith("res") }.first().split("&").first()
        val token = link.split("&").last()

        return Video("https://flowcasts.uni-hannover.de/nodes/$node/$resolution.mp4?$token", video.name)
    }

    fun checkCourseForVids(course: Course): Course? {
        driver.get(course.link)

        val videoElements = driver.findElementById("tabs")
            .findElements(By.id("nav_course_recordings"))

        if(videoElements.isNotEmpty()) {
            return Course(
                link = videoElements[0].findElement(By.xpath("a")).getAttribute("href"),
                name = course.name)
        }

        return null
    }

    fun checkCoursesForFiles(course: Course): Course? {
        driver.get(course.link)

        val videoElements = driver.findElementByXPath("/html/body/div/div[3]/div[1]")
            .findElement(By.id("tabs"))
            .findElements(By.id("nav_course_files"))

        if(videoElements.isNotEmpty()) {
            return Course(
                link = videoElements[0].findElement(By.xpath("a")).getAttribute("href"),
                name = course.name)
        }

        return null
    }

    fun getFileLinks(course: Course): List<StudFile> {
        driver.get(course.link)
        val files = ArrayList<StudFile>()

        driver.findElementByXPath("/html/body/div/div[3]/div[2]/div[2]/form/table/tbody[2]")
            .findElements(By.xpath("tr[1]/td[3]")).forEach {
                files.add(StudFile(
                    name = it.text,
                    link = it.findElement(By.xpath("a")).getAttribute("href")
                ))
        }

        return files
    }

    fun getVideoLinks(course: Course): List<Video> {
        driver.get(course.link)

        sleep(2_00)

        var videoLink: List<Video> = ArrayList()
        try {
            videoLink = driver
                .findElementByXPath("/html/body/div/div[3]/div[2]/div[2]/table/tbody")
                .findElements(By.xpath("tr")).map {
                    val element = it.findElement(By.xpath("td[2]/a"))
                    Video(element.getAttribute("href").toString(), element.text)
                }
        } catch (e: Exception) {
            // DO NOTHING
            //e.printStackTrace()
        }

        return videoLink
    }

}